| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | List of all members
SeisSingleTraceProc Class Reference
Seis

Single trace processing executor. More...

`#include <seissingtrcproc.h>`

Inheritance diagram for SeisSingleTraceProc:
[legend]

## Public Member Functions
| SeisSingleTraceProc (const IOObj &in, const IOObj &out, const char *nm="Trace processor", const IOPar *iniopar=nullptr, const uiString &msg=uiStrings::sProcessing(), int compnr=-1)
| SeisSingleTraceProc (const IOObj &out, const char *nm, const uiString &msg)
| SeisSingleTraceProc (const SeisStoreAccess::Setup &inpsu, const SeisStoreAccess::Setup &outsu, const char *nm="Trace processor", const uiString &msg=uiStrings::sProcessing())
| SeisSingleTraceProc (ObjectSet< IOObj >, const IOObj &, const char *nm="Trace processor", ObjectSet< IOPar > *iniopars=nullptr, const uiString &msg=uiStrings::sProcessing(), int compnr=-1)
virtual | ~SeisSingleTraceProc ()
bool | addReader (const IOObj &, const IOPar *iop)
| Must be done before any step.
uiString | errMsg () const
void | fillNullTraces (bool yn=true)
const SeisTrc & | getInputTrace ()
| Only available during execution.
SeisTrc & | getTrace ()
| Only available during execution.
bool | isOK () const
od_int64 | nrDone () const override
int | nrSkipped () const
int | nrWritten () const
const SeisTrcReader * | reader (int idx=0) const
| Only available during execution.
const Scaler * | scaler () const
void | setExtTrcToSI (bool yn)
bool | setInput (const IOObj &, const IOObj &, const char *, const IOPar *, const uiString &)
| Must be done before any step.
void | setProcPars (const IOPar &, bool is2d)
| Sets all above proc pars from IOPar.
void | setResampler (SeisResampler *)
void | setScaler (Scaler *)
| Scaler becomes mine.
void | setTotalNrIfUnknown (int nr)
void | setTracesPerStep (int n)
| default is 10
void | skipCurTrc ()
| will also be checked after processing CB
void | skipNullTraces (bool yn=true)
od_int64 | totalNr () const override
uiString | uiMessage () const override
uiString | uiNrDoneText () const override
const SeisTrcWriter * | writer () const
| Only available during execution.
Public Member Functions inherited from Executor
| Executor (const char *nm)
virtual | ~Executor ()
int | doStep () override
bool | execute () override
bool | go (od_ostream &s, bool isfirst=true, bool islast=true, int delaybtwnstepsinms=0)
bool | go (od_ostream *s=0, bool isfirst=true, bool islast=true, int delaybtwnstepsinms=0)
Public Member Functions inherited from SequentialTask
| SequentialTask (const char *nm=nullptr)
virtual | ~SequentialTask ()
bool | execute () override
Public Member Functions inherited from ReportingTask
| ReportingTask (const ReportingTask &)=delete
virtual | ~ReportingTask ()
void | getProgress (const ReportingTask &)
ReportingTask & | operator= (const ReportingTask &)=delete
void | setSimpleMeter (bool yn, int repperc)
int | simpleMeterStep () const
bool | useSimpleMeter () const
Public Member Functions inherited from Task
| Task (const Task &)=delete
virtual | ~Task ()
virtual void | controlWork (Control)
virtual void | enableWorkControl (bool=true)
| Must be called before execute()
virtual uiRetVal | errorWithDetails () const
virtual Control | getState () const
Task & | operator= (const Task &)=delete
bool | workControlEnabled () const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Public Attributes
Notifier< SeisSingleTraceProc > | inputready_
Notifier< SeisSingleTraceProc > | proctobedone_
Notifier< SeisSingleTraceProc > | traceselected_
Public Attributes inherited from Executor
Notifier< Executor > | poststep
| Only when MoreToDo will be returned.
Notifier< Executor > | prestep
Public Attributes inherited from ReportingTask
Notifier< ReportingTask > | progressUpdated

## Protected Member Functions
bool | addReader ()
int | getFillTrc ()
int | getNextTrc ()
bool | goImpl (od_ostream *, bool, bool, int) override
bool | is2D () const
bool | is3D () const
bool | isPS () const
bool | nextReader ()
int | nextStep () override
void | prepareNullFilling ()
bool | prepareTrc ()
bool | setInput ()
virtual void | wrapUp ()
bool | writeTrc ()
Protected Member Functions inherited from SequentialTask
virtual bool | doFinish (bool success, od_ostream *=nullptr)
virtual bool | doPrepare (od_ostream *=nullptr)
Protected Member Functions inherited from ReportingTask
| ReportingTask (const char *nm=nullptr)
void | incrementProgress ()
ProgressMeter * | progressMeter () const
void | reportProgressFinished ()
void | reportProgressStarted ()
void | resetProgress ()
void | setProgressMeter (ProgressMeter *) override
| Must be called before execute()
void | updateProgressMeter (bool forced=false, od_int64 *totalnr=0)
void | updateReportedName ()
Protected Member Functions inherited from Task
| Task (const char *nm=nullptr)
virtual bool | shouldContinue ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Protected Attributes
bool | allszsfound_ = true
uiString | curmsg_
int | currdridx_ = -1
uiString | errmsg_
BufferString | execnm_
bool | extendtrctosi_ = false
BinID | fillbid_
TrcKeySampling | fillhs_
bool | fillnull_ = false
SeisTrc * | filltrc_ = nullptr
uiString | initmsg_
SeisStoreAccess::Setup | inpsetup_
SeisTrc & | intrc_
int | nrskipped_ = 0
int | nrwr_ = 0
SeisStoreAccess::Setup | outsetup_
ObjectSet< SeisTrcReader > | rdrs_
SeisResampler * | resampler_ = nullptr
Scaler * | scaler_ = nullptr
bool | skipcurtrc_
bool | skipnull_ = false
int | totnr_ = -1
int | trcsperstep_ = 10
SeisTrc * | worktrc_
SeisTrcWriter * | wrr_ = nullptr
MultiID & | wrrkey_
Protected Attributes inherited from Task
Control | control_ = Task::Run
Threads::ConditionVar * | workcontrolcondvar_ = nullptr
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from Task
enum | Control { Run , Pause , Stop }
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Static Public Member Functions inherited from SequentialTask
static int | ErrorOccurred ()
static int | Finished ()
static int | MoreToDo ()
static int | WarningAvailable ()
Static Public Member Functions inherited from ReportingTask
static PtrMan< ProgressMeter > | getTextProgressMeter (od_ostream &, const IOPar *iop=nullptr)
static bool | needSimpleLogging (const IOPar &)
static const char * | sKeySimpleLogging ()
static const char * | sKeySimpleLoggingStep ()
Static Public Member Functions inherited from Task
static uiString | uiStdNrDoneText ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Detailed Description

Single trace processing executor.

When a trace info is read, the selection notifier is triggered. You can then use skipCurTrc(). When the trace is read, the processing notifier is triggered. You can set your own trace as output trace, otherwise the input trace will be taken.

<>

## Constructor & Destructor Documentation

## ◆ SeisSingleTraceProc() [1/4]

SeisSingleTraceProc::SeisSingleTraceProc | ( | const IOObj & | in,
|  | const IOObj & | out,
|  | const char * | nm = "Trace processor",
|  | const IOPar * | iniopar = nullptr,
|  | const uiString & | msg = uiStrings::sProcessing(),
|  | int | compnr = -1 )

## ◆ SeisSingleTraceProc() [2/4]

SeisSingleTraceProc::SeisSingleTraceProc | ( | const SeisStoreAccess::Setup & | inpsu,
|  | const SeisStoreAccess::Setup & | outsu,
|  | const char * | nm = "Trace processor",
|  | const uiString & | msg = uiStrings::sProcessing() )

## ◆ ~SeisSingleTraceProc()

virtual SeisSingleTraceProc::~SeisSingleTraceProc | ( |  | ) |
| virtual

## ◆ SeisSingleTraceProc() [3/4]

SeisSingleTraceProc::SeisSingleTraceProc | ( | ObjectSet< IOObj > | ,
|  | const IOObj & | ,
|  | const char * | nm = "Trace processor",
|  | ObjectSet< IOPar > * | iniopars = nullptr,
|  | const uiString & | msg = uiStrings::sProcessing(),
|  | int | compnr = -1 )

## ◆ SeisSingleTraceProc() [4/4]

SeisSingleTraceProc::SeisSingleTraceProc | ( | const IOObj & | out,
|  | const char * | nm,
|  | const uiString & | msg )

## Member Function Documentation

## ◆ addReader() [1/2]

bool SeisSingleTraceProc::addReader | ( |  | ) |
| protected

## ◆ addReader() [2/2]

bool SeisSingleTraceProc::addReader | ( | const IOObj & | ,
|  | const IOPar * | iop )

Must be done before any step.

## ◆ errMsg()

uiString SeisSingleTraceProc::errMsg | ( |  | ) | const
| inline

## ◆ fillNullTraces()

void SeisSingleTraceProc::fillNullTraces | ( | bool | yn = true | ) |
| inline

## ◆ getFillTrc()

int SeisSingleTraceProc::getFillTrc | ( |  | ) |
| protected

## ◆ getInputTrace()

const SeisTrc & SeisSingleTraceProc::getInputTrace | ( |  | ) |
| inline

Only available during execution.

## ◆ getNextTrc()

int SeisSingleTraceProc::getNextTrc | ( |  | ) |
| protected

## ◆ getTrace()

SeisTrc & SeisSingleTraceProc::getTrace | ( |  | ) |
| inline

Only available during execution.

## ◆ goImpl()

bool SeisSingleTraceProc::goImpl | ( | od_ostream * | ,
|  | bool | ,
|  | bool | ,
|  | int | )
| override protected virtual

Reimplemented from Executor.

## ◆ is2D()

bool SeisSingleTraceProc::is2D | ( |  | ) | const
| protected

## ◆ is3D()

bool SeisSingleTraceProc::is3D | ( |  | ) | const
| protected

## ◆ isOK()

bool SeisSingleTraceProc::isOK | ( |  | ) | const
| inline

## ◆ isPS()

bool SeisSingleTraceProc::isPS | ( |  | ) | const
| protected

## ◆ nextReader()

bool SeisSingleTraceProc::nextReader | ( |  | ) |
| protected

## ◆ nextStep()

int SeisSingleTraceProc::nextStep | ( |  | ) |
| override protected virtual

Return values

  MoreToDo() | Not finished. Call me again.
  Finished() | Nothing more to do.
  ErrorOccurred() | Something went wrong.

Note
  if function returns a value greater than cMoreToDo(), it should be interpreted as cMoreToDo().

Implements SequentialTask.

## ◆ nrDone()

od_int64 SeisSingleTraceProc::nrDone | ( |  | ) | const
| override virtual

Note
  nrDone is only used for displaying progress and will be compared to totalNr to show user how large part of the task that is finished.

Reimplemented from Task.

## ◆ nrSkipped()

int SeisSingleTraceProc::nrSkipped | ( |  | ) | const
| inline

## ◆ nrWritten()

int SeisSingleTraceProc::nrWritten | ( |  | ) | const
| inline

## ◆ prepareNullFilling()

void SeisSingleTraceProc::prepareNullFilling | ( |  | ) |
| protected

## ◆ prepareTrc()

bool SeisSingleTraceProc::prepareTrc | ( |  | ) |
| protected

## ◆ reader()

const SeisTrcReader * SeisSingleTraceProc::reader | ( | int | idx = 0 | ) | const
| inline

Only available during execution.

## ◆ scaler()

const Scaler * SeisSingleTraceProc::scaler | ( |  | ) | const
| inline

## ◆ setExtTrcToSI()

void SeisSingleTraceProc::setExtTrcToSI | ( | bool | yn | ) |
| inline

## ◆ setInput() [1/2]

bool SeisSingleTraceProc::setInput | ( |  | ) |
| protected

## ◆ setInput() [2/2]

bool SeisSingleTraceProc::setInput | ( | const IOObj & | ,
|  | const IOObj & | ,
|  | const char * | ,
|  | const IOPar * | ,
|  | const uiString & | )

Must be done before any step.

## ◆ setProcPars()

void SeisSingleTraceProc::setProcPars | ( | const IOPar & | ,
|  | bool | is2d )

Sets all above proc pars from IOPar.

## ◆ setResampler()

void SeisSingleTraceProc::setResampler | ( | SeisResampler * |  | ) |

## ◆ setScaler()

void SeisSingleTraceProc::setScaler | ( | Scaler * |  | ) |

Scaler becomes mine.

## ◆ setTotalNrIfUnknown()

void SeisSingleTraceProc::setTotalNrIfUnknown | ( | int | nr | ) |
| inline

## ◆ setTracesPerStep()

void SeisSingleTraceProc::setTracesPerStep | ( | int | n | ) |
| inline

default is 10

## ◆ skipCurTrc()

void SeisSingleTraceProc::skipCurTrc | ( |  | ) |
| inline

will also be checked after processing CB

## ◆ skipNullTraces()

void SeisSingleTraceProc::skipNullTraces | ( | bool | yn = true | ) |
| inline

## ◆ totalNr()

od_int64 SeisSingleTraceProc::totalNr | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ uiMessage()

uiString SeisSingleTraceProc::uiMessage | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ uiNrDoneText()

uiString SeisSingleTraceProc::uiNrDoneText | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ wrapUp()

virtual void SeisSingleTraceProc::wrapUp | ( |  | ) |
| protected virtual

## ◆ writer()

const SeisTrcWriter * SeisSingleTraceProc::writer | ( |  | ) | const
| inline

Only available during execution.

## ◆ writeTrc()

bool SeisSingleTraceProc::writeTrc | ( |  | ) |
| protected

## Member Data Documentation

## ◆ allszsfound_

bool SeisSingleTraceProc::allszsfound_ = true
| protected

## ◆ curmsg_

uiString SeisSingleTraceProc::curmsg_
| protected

## ◆ currdridx_

int SeisSingleTraceProc::currdridx_ = -1
| protected

## ◆ errmsg_

uiString SeisSingleTraceProc::errmsg_
| protected

## ◆ execnm_

BufferString SeisSingleTraceProc::execnm_
| protected

## ◆ extendtrctosi_

bool SeisSingleTraceProc::extendtrctosi_ = false
| protected

## ◆ fillbid_

BinID SeisSingleTraceProc::fillbid_
| protected

## ◆ fillhs_

TrcKeySampling SeisSingleTraceProc::fillhs_
| protected

## ◆ fillnull_

bool SeisSingleTraceProc::fillnull_ = false
| protected

## ◆ filltrc_

SeisTrc* SeisSingleTraceProc::filltrc_ = nullptr
| protected

## ◆ initmsg_

uiString SeisSingleTraceProc::initmsg_
| protected

## ◆ inpsetup_

SeisStoreAccess::Setup SeisSingleTraceProc::inpsetup_
| protected

## ◆ inputready_

Notifier<SeisSingleTraceProc> SeisSingleTraceProc::inputready_

## ◆ intrc_

SeisTrc& SeisSingleTraceProc::intrc_
| protected

## ◆ nrskipped_

int SeisSingleTraceProc::nrskipped_ = 0
| protected

## ◆ nrwr_

int SeisSingleTraceProc::nrwr_ = 0
| protected

## ◆ outsetup_

SeisStoreAccess::Setup SeisSingleTraceProc::outsetup_
| protected

## ◆ proctobedone_

Notifier<SeisSingleTraceProc> SeisSingleTraceProc::proctobedone_

## ◆ rdrs_

ObjectSet<SeisTrcReader> SeisSingleTraceProc::rdrs_
| protected

## ◆ resampler_

SeisResampler* SeisSingleTraceProc::resampler_ = nullptr
| protected

## ◆ scaler_

Scaler* SeisSingleTraceProc::scaler_ = nullptr
| protected

## ◆ skipcurtrc_

bool SeisSingleTraceProc::skipcurtrc_
| protected

## ◆ skipnull_

bool SeisSingleTraceProc::skipnull_ = false
| protected

## ◆ totnr_

int SeisSingleTraceProc::totnr_ = -1
| protected

## ◆ traceselected_

Notifier<SeisSingleTraceProc> SeisSingleTraceProc::traceselected_

## ◆ trcsperstep_

int SeisSingleTraceProc::trcsperstep_ = 10
| protected

## ◆ worktrc_

SeisTrc* SeisSingleTraceProc::worktrc_
| protected

## ◆ wrr_

SeisTrcWriter* SeisSingleTraceProc::wrr_ = nullptr
| protected

## ◆ wrrkey_

MultiID& SeisSingleTraceProc::wrrkey_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025